; Datenformat wandeln

.global Bin8asc2,Bin16asc4,Bin16asc5,Bin17asc5,Bin16asc3
;.include "allgdef.inc"

; bin nach 2 Byte ASCII, max. bis 99

Bin8asc2:
	clr		w4
	mov		#10,w5
	repeat	#17
	div.u	w2,w5			; w2 : w5 = w0,w1
	ior		#0x30,w0
	mov		w0,w4
	ior		#0x30,w1
	mov		w1,w3
	return



; 17bit bin nach 5 Byte ASCII max. 99999
; Eingang: w3,w2 Ausgang: w4,w3,w2,w1,w0

Bin17asc5:
	mov		#10000,w6
;	mov		w0,w4
;	mov		w1,w5
	repeat	#17
	div.ud	w2,w6		; w5,w4 : w6 = w0, rest in w1
	mov		w0,w4		; 5.Stelle (HW)
	ior		#0x30,w4
	mov		w1,w5
	mov		#1000,w6
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w3   	; 4.Stelle
	ior		#0x30,w3
	mov		w1,w5
	mov		#100,w6
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w2		; 3. Stelle
	ior		#0x30,w2
	mov		w1,w5
	mov		#10,w6
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	exch	w1,w0		; 2. und 1. Stelle
	ior		#0x30,w0
	ior		#0x30,w1
	return

; 16bit bin nach 5 Byte ASCII max. 32767
; Eingang: w0, Ausgang: w4,w3,w2,w1,w0

Bin16asc5:
	push	w6
	mov		#10000,w6
	mov		w0,w5
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w4		; 5.Stelle (HW)
	ior		#0x30,w4
	mov		w1,w5
	mov		#1000,w6
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w3   	; 4.Stelle
	ior		#0x30,w3
	mov		w1,w5
	mov		#100,w6
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w2		; 3. Stelle
	ior		#0x30,w2
	mov		w1,w5
	mov		#10,w6
	repeat	#17
 	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	exch	w1,w0		; 2. und 1. Stelle
	ior		#0x30,w0
	ior		#0x30,w1
	pop		w6
	return

; 16bit bin nach 3 Byte ASCII max. 999
; Eingang: w0, Ausgang: w2,w1,w0
Bin16asc3:
	mov		#100,w6
	mov		w0,w5
	repeat	#17
	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	mov		w0,w2		; 3. Stelle
	ior		#0x30,w2
	mov		w1,w5
	mov		#10,w6
	repeat	#17
 	div.u	w5,w6		; w5 : w6 = w0, rest in w1
	exch	w1,w0		; 2. und 1. Stelle
	ior		#0x30,w0
	ior		#0x30,w1
	return

; 16bit bin nach 4 Byte ASCII max. 9999
; Eingang: w0, Ausgang: w3,w2,w1,w0

Bin16asc4:
	mov		w0,w5
	mov		#1000,w8
	repeat	#17
	div.u	w5,w8		; w5 : w6 = w0, rest in w1
	mov		w0,w3   	; 4.Stelle
	ior		#0x30,w3
	mov		w1,w5
	mov		#100,w8
	repeat	#17
	div.u	w5,w8		; w5 : w6 = w0, rest in w1
	mov		w0,w2		; 3. Stelle
	ior		#0x30,w2
	mov		w1,w5
	mov		#10,w8
	repeat	#17
 	div.u	w5,w8		; w5 : w6 = w0, rest in w1
	exch	w1,w0		; 2. und 1. Stelle
	ior		#0x30,w0
	ior		#0x30,w1
	return


