; LCD initialisierung
 ; LCD-Modul mit 4 x 20 Zeichen

.include "allgdef.inc"
.text
.global Lcdinit,warten
.equ    lcdbf,7
 
Lcdinit:
; 20ms warten

	mov		#20000,w0			; 20ms
	call	warten
; 8-bit Modus	
	mov		#0x30,w0
	call	Lcdinitsnd
; 5ms warten	
	mov		#20000,w0          ; 5ms
	call	warten
; nochmal
	mov		#0x30,w0
	call	Lcdinitsnd
; 200us warten
    mov     #2000,w0
    call    warten
 ; nochmal   
	mov		#0x30,w0
	call	Lcdinitsnd
; frei?
    call    Auffreigabewarten
    mov     #0x38,w0
    call    Lcdinitsnd
; LCD aus    
    call    Auffreigabewarten
    mov     #0x08,w0
    call    Lcdinitsnd
; nach rechts, kein shift
    call    Auffreigabewarten
    mov     #0x06,w0
    call    Lcdinitsnd
; LCD lschen
    call    Auffreigabewarten
    mov     #0x01,w0
    call    Lcdinitsnd
; LCD ein    
    call    Auffreigabewarten
    mov     #0x0c,w0
    call    Lcdinitsnd
    mov     #20000,w0
    call    warten
    return
	
warten:
    cp0     w0
    bra     nz,warten1us
    return
warten1us:
    repeat  #27
    nop
    nop
    dec     w0,w0
    bra     warten


Lcdinitsnd:

    bclr    w0,#lcdrs	
    bclr    w0,#lcdrw
    mov     w0,LATD
    repeat  #200
    nop
    nop
    bset    LATF,#lcde1
    bset    LATF,#lcde2
    Repeat  #8
    nop
    nop
    bclr    LATF,#lcde1	
    bclr    LATF,#lcde2
    Repeat  #8
    nop
    nop
    return

; Warten bis LCD-Controller fertig sind    
Auffreigabewarten:
    mov     #2000,w0
    call    warten
    return
    
    


		
