 ; RELCON verwaltet die Schalterstellungen fr die 3 Relais

.equ __30F6012A, 1
.include "p30F6012A.inc"
.include "allgdef.inc"

.global	Relcon

Relcon:
 	mov		relsta,w0
 	bra		w0
	
	bra		rel0
	bra		rel1
	bra		rel2
	bra		rel3

rel0:
    return

; Temepratur berwachen
rel1:
    btss    merker,#tempalarm
    bra     rel1v                ; Temeratur OK
    mov     #4,w0
    mov     w0,melder30v
    mov     w0,melderm15v
    bra     rel3
rel1v:
; 5A-Schalter berwachen    
    mov     PORTF,w0
    btsc    w0,#schalter5a
    bra     rel1d
; 5A-Schalter ist nicht aus! Also: 0V am Eingang
    mov     #100,w0
    mov     w0,schalter5azlr
    mov     limit5a,w0
    mov     strom5a,w1
    add     #limithysterese,w1     ; Begrenzt?
    sub     w0,w1,w0
    bra     geu,rel1a
    mov     #2,w0                  ; text "Linit"
    bra     rel1b
rel1a:
    mov     #1,w0                  ; Text "Ein"
rel1b:
    mov     w0,melder30v
    inc     relsta
    return

; Schalter ist aus! Also: 5V am Eingang   
rel1d:
    cp0     schalter5azlr
    bra     nz,rel1e
    mov     #0,w0               ; Text "Aus"
    mov     w0,melder30v
    inc     relsta
    return
rel1e:   
    dec     schalter5azlr
    bra     nz,rel1f
    mov     strom5a+2,w0
    mov     w0,strom5akorr
    inc     relsta
    return
rel1f:
    mov     #3,w0               ; "set 0"
    mov     w0,melder30v
    inc     relsta
    return
      
; 3A-Schalter berwachen    
rel2:
    mov     PORTF,w0
    btsc    w0,#schalter3a
    bra     rel2d
; 3A-Schalter ist nicht aus!
    mov     #100,w0
    mov     w0,schalter3azlr
    mov     limit3a,w0
    mov     strom3a,w1
    add     #limithysterese,w1     ; Begrenzt?
    sub     w0,w1,w0
    bra     geu,rel2a                ; ja             
    mov     #2,w0                  ; text "Linit"
    bra     rel2b
rel2a:
    mov     #1,w0                  ; Text "Ein"
rel2b:
    mov     w0,melderm15v
    inc     relsta
    return

; Schalter ist aus!    
rel2d:
    cp0     schalter3azlr
    bra     nz,rel2e
    mov     #0,w0               ; Text "Aus"
    mov     w0,melderm15v
    inc     relsta
    return
rel2e:   
    dec     schalter3azlr
    bra     nz,rel2f
    mov     strom3a+2,w0        ; akt. Messwert wenn Strom = 0
    mov     w0,strom3akorr
    inc     relsta
    return
rel2f:
    mov     #3,w0               ; "set 0"
    mov     w0,melderm15v
    inc     relsta
    return
           
; 0,3A-Schalter berwachen    
rel3:
    mov     PORTF,w0
    btsc    w0,#schalter0p3a
    bra     rel3d
; 0,3A-Schalter ist nicht aus!
    mov     #100,w0
    mov     w0,schalter0p3azlr
    mov     limit0p3a,w0
    mov     strom0p3a,w1
    add     #limithysterese,w1     ; Begrenzt?
    sub     w0,w1,w0
    bra     geu,rel3a                ; ja             
    mov     #2,w0                  ; text "Linit"
    bra     rel3b
rel3a:
    mov     #1,w0                  ; Text "Ein"
rel3b:
    mov     w0,melderp15v
    clr     relsta
    return

; Schalter ist aus!    
rel3d:
    cp0     schalter0p3azlr
    bra     nz,rel3e
    mov     #0,w0               ; Text "Aus"
    mov     w0,melderp15v
    clr     relsta
    return
rel3e:   
    dec     schalter0p3azlr
    bra     nz,rel3f
    mov     strom0p3a+2,w0
    mov     w0,strom0p3akorr
    clr     relsta
    return
rel3f:
    mov     #3,w0               ; "set 0"
    mov     w0,melderp15v
    clr     relsta
    return
    
