; MONITOR fr NTG9200 Labornetzgert tragbar
.global Monitor

; Ausgangs-String:
; Zeile (1 bis 4), Spalte (0 bis 26), Text byteweise, Endezeichen 0x0

Monitor:
   	mov		lcdsta,w0
	cp0		w0
	bra		z,monitorv		; LCDout frei?
	return                  ; nein
monitorv:
	mov		monsta,w0
	bra		w0
	bra		monitor0
	bra		monitor1
	bra		monitor2
	bra		monitor3
	bra		monitor4
	bra		monitor5
	bra		monitor6
	bra		monitor7
	bra		monitor8
	bra		monitor9
	bra		monitor10
	bra		monitor11
	bra		monitor12
	bra		monitor13
	bra		monitor14
	bra		monitor15
	bra		monitor16

; LCD Fixtext, Zeile1
monitor0:
	mov		#psvoffset(Textz1),w8
	bra		monitor3a

; LCD Fixtext, Zeile2
monitor1:
	mov		#psvoffset(Textz2),w8
	bra		monitor3a

; LCD Fixtext, Zeile3
monitor2:
	mov		#psvoffset(Textz3),w8
	bra		monitor3a

; LCD Fixtext, Zeile4
monitor3:
	mov		#psvoffset(Textz4),w8
monitor3a:
    mov     #lcdpuffer,w7
    call    Holetext
    bra     next
    
; Spannung anzeigen 30V-Regler, 4095 digit = 30.86V
monitor4:
    mov     spannung30v,w0
    mov     #0x0101,w4      ; Zeile 1, spalte 1
    call    Spannungzumlcd
    bra     next 
    
 ; Spannung anzeigen -15V-Regler, 4095  digit = 15.37V
monitor5:
    mov     spannungm15v,w0
    mov     #0x0901,w4      ; Zeile 1, spalte 9  
    call    Spannungzumlcd
    bra     next
           
 ; Spannung anzeigen +15V-Regler, 4095  digit = -15.37V
monitor6:
    mov     spannungp15v,w0
    mov     #0x1001,w4      ; Zeile 1, spalte 17
    call    Spannungzumlcd
    bra     next
    
 ; Strombegrenzung anzeigen 30V-Regler, 4095  digit = 6.143A
monitor7:
    mov     limit5a,w0
    mov     #0x0102,w4      ; Zeile 2, spalte 1
    call    Stromzumlcd
    bra     next    

 ; Strombegrenzung anzeigen 15V pos Regler, 4095  digit = 3.086A
monitor8:
    mov     limit3a,w0
    mov     #0x0802,w4      ; Zeile 2, spalte 8
    call    Stromzumlcd    
    bra     next

 ; Strombegrenzung anzeigen 15V neg Regler, 4095  digit = 0.3086A
monitor9:
    mov     limit0p3a,w0
    mov     #0x1102,w4      ; Zeile 2, spalte 16
    call    Stromzumlcd2    
    bra     next

 ; Strom anzeigen 30V-Regler, 4095  digit = 6.143A
monitor10:
    mov     strom5a,w0
    mov     #0x0103,w4      ; Zeile 3, spalte 1
    call    Stromzumlcd
    bra     next

 ; Strom anzeigen 15V neg Regler, 4095  digit = 3.086A
monitor11:
    mov     strom3a,w0
    mov     #0x0803,w4      ; Zeile 3, spalte 8
    call    Stromzumlcd    
    bra     next

 ; Strom anzeigen 15V pos Regler, 4095  digit = 0.3086A
monitor12:
    mov     strom0p3a,w0
    mov     #0x1103,w4      ; Zeile 3, spalte 17
    call    Stromzumlcd2    
    bra     next

; Temperatur anzeigen, 2 Stellen
monitor13:
    mov     tempsensor,w2
    call    Bin8asc2        ; w2 >> w3,w4
    mov     #lcdpuffer,w7
    mov     #0x1804,w0      ; Zeile 4, Spalte 24
    mov     w0,[w7++]
    mov.b   w4,[w7++]
    mov.b   w3,[w7++]
    mov     #0x27,w0
    mov.b   w0,[w7++]
    clr     w0
    mov.b   w0,[w7++]
    bra     next

; Meldungen in Zeile 4
monitor14:
    mov     melder30v,w0
    mov     melder30vzsp,w1
    cp      w0,w1
    bra     z,monitor14a
    mov     w0,melder30vzsp
    mov     #lcdpuffer,w7
    mov     #0x0104,w1
    mov     w1,[w7++]
    call    Holehinweis
    bra     next
monitor14a:
    inc     monsta
    return

monitor15:
    mov     melderm15v,w0
    mov     melderm15vzsp,w1
    cp      w0,w1
    bra     z,monitor15a
    mov     w0,melderm15vzsp
    mov     #lcdpuffer,w7
    mov     #0x0804,w1
    mov     w1,[w7++]
    call    Holehinweis
    bra     next
monitor15a:
    inc     monsta
    return    
   
monitor16:
    mov     #4,w0
    mov     w0,monsta
    mov     melderp15v,w0
    mov     melderp15vzsp,w1
    cp      w0,w1
    bra     z,monitor16a
    mov     w0,melderp15vzsp
    mov     #lcdpuffer,w7
    mov     #0x0f04,w1
    mov     w1,[w7++]
    call    Holehinweis
    bra     lcdstart
monitor16a:
    return    
     
; ********************************************
; LCDOUT starten
; ********************************************
next:
    inc     monsta
lcdstart:
    mov     #1,w0
    mov     w0,lcdsta
    mov     #lcdpuffer,w0
    mov     w0,lcdzgr
    return
    
    
