; RAM NTG9200

.global ramanfang,ramend
.global lcdsta,lcdzgr,lcdpuffer
.global monsta,melder30v,melder30vzsp,melderp15v,melderp15vzsp,melderm15v,melderm15vzsp
.global spannung30v,spannungm15v,spannungp15v
.global limit5a,limit3a,limit0p3a
.global strom5a,strom3a,strom0p3a
.global strom5akorr,strom3akorr,strom0p3akorr
.global schalter5azlr,schalter3azlr,schalter0p3azlr
.global elko30v,elkom15v,phase5a,phase3a
.global trimmer30v,trimmerm15v,tempsensor
.global adwsta,relsta,betsta
.global takt10,bettimer,merker
.global testzgr,testpuffer

.section	MAINRAM, bss, address(0x850)

ramanfang:      .space  2

; LCD-Daten
lcdsta:         .space  2
lcdzgr:         .space  2
lcdpuffer:      .space  80
; Monitor
monsta:         .space  2
melder30v:      .space  2
melder30vzsp:   .space  2
melderp15v:     .space  2
melderp15vzsp:  .space  2
melderm15v:     .space  2
melderm15vzsp:  .space  2
; Analogwerte vom ADW, Spannung
spannung30v:    .space  2
spannungm15v:   .space  2
spannungp15v:   .space  2
; Analogwerte vom ADW, Stromgegrenzung
limit5a:        .space  2
limit3a:        .space  2
limit0p3a:      .space  2
; Analogwerte vom ADW, Ist-Strom und Messwert nicht korregiert
strom5a:        .space  4
strom3a:        .space  4
strom0p3a:      .space  4
; Messwert am Power-Transistor
elko30v:        .space  2  
elkom15v:       .space  2 
; Analogwert der Trimmer vom ADW
trimmer30v:     .space  2   ; RV2
trimmerm15v:    .space  2   ; RV3
; Phasenzeiger 
phase5a:        .space  2
phase3a:        .space  2
; Analogwert Temperatursensor vom ADW
tempsensor:     .space  2
; Statusthler
adwsta:         .space  2
betsta:         .space  2
relsta:         .space  2
; Korrekturwerte fr die Strommessung
strom5akorr:    .space  2
strom3akorr:    .space  2
strom0p3akorr:  .space  2
; Schalter entprellen
schalter5azlr:  .space  2
schalter3azlr:  .space  2
schalter0p3azlr:  .space  2
; Diverse
merker:         .space  2
testzgr:        .space  2
testpuffer:     .space  68

ramende:        .space  2
stackanfang:    .space  2
